--[[Author:		DieenDieen 
	License:	All Rights Reserved
	Contact:	
-- global lookup
]]

local folder, core = ...
MO = core --global table

-- local
title		= "Mail Outbox"
version		= GetAddOnMetadata(folder, "X-Curse-Packaged-Version") or ""
titleFull	= title.." "..version
outgoingmail = {};
outgoingmailitems = {};
outgoingmailmoney = 0;
outgoingmailCOD = 0;

-- Isolate the environment
local _G = getfenv(0)
setmetatable(MO, {__index = _G})
setfenv(1, MO)

core = LibStub("AceAddon-3.0"):NewAddon("MailOutbox", "AceConsole-3.0",  "AceHook-3.0", "AceEvent-3.0") 

local regEvents = {
	"MAIL_SEND_INFO_UPDATE",
	"SEND_MAIL_COD_CHANGED",
	"MAIL_SEND_SUCCESS",
	"SEND_MAIL_MONEY_CHANGED",
	"MAIL_CLOSED",
}

function core:OnInitialize()
    --print "---mailoutbox init";
    self:RegisterChatCommand("mailoutbox", "MySlashProcessorFunc") 	
end





function core:OnEnable()
   --print "---mailoutbox OnEnable";
   for i, event in pairs (regEvents) do 
		self:RegisterEvent(event)
	end	
end

function core:MAIL_CLOSED(event, ...)
	mailOpen = 0
end

function reportMailInfo()
   if outgoingmail.Valid then
		outgoingmail.Timestamp = date("%Y/%m/%d %H:%M:%S");
		local countableitems = (#outgoingmail.Items).." item";
		if (#outgoingmail.Items > 1) then
		     countableitems = countableitems.."s";
		  elseif (#outgoingmail.Items == 0) then
		     countableitems = "no items";
		  end;
		ChatFrame1:AddMessage (outgoingmail.Timestamp..":(to:"..outgoingmail.Recipient..", "..countableitems..", "..(outgoingmail.Money/10000).."G, COD "..(outgoingmail.COD/10000).."G) '"..outgoingmail.Subject.."'");
		local ItemList="";
		for index=1,#outgoingmail.Items  do
		   ItemList = ItemList.." "..(outgoingmail.Items [index].Link).."x"..(outgoingmail.Items [index].Count);
		   end
		if (0<#outgoingmail.Items) then 
		   ChatFrame1:AddMessage (ItemList);
		   end;
   end;
end;


function UpdateSendMailInfo()
--[[
	print "------"; 
    print (SendMailSubjectEditBox:GetText());
	print (SendMailNameEditBox:GetText());
	print (SendMailBodyEditBox:GetText());
	print (SendMailMoneyText:GetText());
	print (MoneyInputFrame_GetCopper(SendMailMoney));
	]]
	outgoingmail = {};
	outgoingmail.Recipient = SendMailNameEditBox:GetText();
	outgoingmail.Subject = SendMailSubjectEditBox:GetText();
	outgoingmail.Body = SendMailBodyEditBox:GetText();
	outgoingmail.Cost = GetSendMailPrice();
	outgoingmail.Items = outgoingmailitems;
	outgoingmail.COD = outgoingmailCOD;    
	outgoingmail.Money = outgoingmailmoney;
	outgoingmail.Valid = true;
end;

function UpdateSendMailitemsInfo()
   outgoingmailitems = {};
   for index=1, 12 do 
		Name, Texture, Count, Quality = GetSendMailItem (index); 
		if Name then    
			local ItemAlreadyInList = false;	
		    for inindex=1,#outgoingmailitems do
		       if outgoingmailitems[inindex].Name == Name then
		             outgoingmailitems[inindex].Count = outgoingmailitems[inindex].Count + Count;
		             ItemAlreadyInList = true;
		          end;
		    end;
		    if not ItemAlreadyInList then
				local NewItem= {};
				NewItem.Name=Name;
				NewItem.Count=Count;
				NewItem.Link=GetSendMailItemLink (index);
				outgoingmailitems [1+#outgoingmailitems] =NewItem;
				ItemAlreadyInList = true;
			end;
		end
	end
	UpdateSendMailInfo();
end;


function core:MAIL_SEND_SUCCESS(event, ...)
    -- print "------mail send succes";
    outgoingmailmoney = 0;
    outgoingmailCOD = 0;
    reportMailInfo();

    -- print (outgoingmail.Money);
    -- print (outgoingmail.COD);    
    
    
    end


function core:SEND_MAIL_MONEY_CHANGED(event, ...)
   -- print "------SEND_MAIL_MONEY_CHANGED";
   
   if GetSendMailMoney()~=0 then
      outgoingmailmoney = GetSendMailMoney();
      end;
   UpdateSendMailInfo();
   
  -- print (outgoingmail.Money);
  -- print (outgoingmail.COD);
      
end

function core:SEND_MAIL_COD_CHANGED(event, ...)
  -- print "------SEND_MAIL_COD_CHANGED";   
    
  if GetSendMailCOD()~=0 then
      outgoingmailmoney = GetSendMailCOD();
   end;
      
    UpdateSendMailInfo();
    
    -- print (outgoingmail.Money);
    -- print (outgoingmail.COD);
end

function core:MAIL_SEND_INFO_UPDATE(event, ...)
   -- print "------MAIL_SEND_INFO_UPDATE";
   UpdateSendMailitemsInfo();	
end


function core:OnDisable()
	
end




----------------------------------------------
function core:MySlashProcessorFunc(input)	--
-- /da function brings up the UI options.	--
----------------------------------------------
--~ 	InterfaceOptionsFrame_OpenToCategory_(profitUI)--Expands the menu.
   print ("------ Mail Outbox running");
end





-----------------------------------------------------







